﻿//########################
//InDesignCS2でリンクされている画像を再リンクし、
//同時にドキュメントない内の同名の画像も再リンクします。
//IndesignCS3でいうとの「すべてのインスタンスを再リンク」のような機能です。
//たけうちとおる
//########################


//ダイアログ表示のおまじない
app.scriptPreferences.userInteractionLevel=1699311169;

main();
function main(){
	var myLinkObject = indd_get_selected_box();
	if(! myLinkObject){
		return;
	}
	filePath = File.openDialog("差し替える画像ファイルを指定してください");
	if (filePath){
		fileObj = new File(filePath);
		if(! fileObj){
			return;
		}
		indd_get_all_box(fileObj,myLinkObject);
	}
}
//全てのページのボックスを得る
function indd_get_all_box(fileObj,myLinkObject){
	var linkobjName = myLinkObject.allGraphics[0].itemLink.name;
	if (app.documents.length != 0){
		var pageObj = app.activeDocument.pages;
		for (p=0; p<pageObj.length; p++){
			app.activeWindow.activePage = app.activeDocument.pages[p];
			total = pageObj[p].allGraphics.length;
			for(s = 0; s<total; s++){
				myPageItem = pageObj[p].allGraphics[s].parent;
				indd_relink_image(myPageItem,fileObj,linkobjName);
			}
		}
	}else{
		alert("ドキュメントを開いてください");
	}
}
//選択されたオブジェクトを調べる
function indd_get_selected_box(){
	if (app.documents.length != 0){
		if (app.selection.length == 1){
			var myselectObjects = new Array;
			return app.selection[0];
		}else{
			alert("配置画像を1つだけ選択して下さい");
		}
	}else{
		alert("ドキュメントを開いてください");
	}
}

//リンクを変更する
function indd_relink_image(myPageItem,fileObj,linkobjName){
	try{
		var filename = myPageItem.allGraphics[0].itemLink.name;
		if(linkobjName== filename){
			myPageItem.allGraphics[0].itemLink.relink (fileObj);
			myPageItem.allGraphics[0].itemLink.update();
		}
	}catch(msg){
		//画像が配置されていない
	}
}